#ifdef GL_ES
precision highp float;
#endif
 
varying vec2 v_texCoord;
uniform sampler2D u_texture;

uniform float time;
 
void main()
{
    gl_FragColor = texture2D(u_texture, v_texCoord);
    
    // Black & White
    /*vec4 color = texture2D(u_texture, v_texCoord);
    float luminance = color.r * 0.299 + color.g * 0.587 + color.b * 0.114;
    float asdf = (1.0 + sin(time))/2.0;
    gl_FragColor = asdf*color + (1.0 - asdf)*vec4(luminance, luminance, luminance, 1.0);*/
    
    // Blur
    /*vec4 sum = vec4(0.0);
    float blurSize = 1.0/768.0;
	sum += texture2D(u_texture, vec2(v_texCoord.x - 4.0 * blurSize, v_texCoord.y)) * 0.05;
	sum += texture2D(u_texture, vec2(v_texCoord.x - 3.0 * blurSize, v_texCoord.y)) * 0.09;
	sum += texture2D(u_texture, vec2(v_texCoord.x - 2.0 * blurSize, v_texCoord.y)) * 0.12;
	sum += texture2D(u_texture, vec2(v_texCoord.x - 1.0 * blurSize, v_texCoord.y)) * 0.15;
	sum += texture2D(u_texture, vec2(v_texCoord.x                 , v_texCoord.y)) * 0.16;
	sum += texture2D(u_texture, vec2(v_texCoord.x + 1.0 * blurSize, v_texCoord.y)) * 0.15;
	sum += texture2D(u_texture, vec2(v_texCoord.x + 2.0 * blurSize, v_texCoord.y)) * 0.12;
	sum += texture2D(u_texture, vec2(v_texCoord.x + 3.0 * blurSize, v_texCoord.y)) * 0.09;
	sum += texture2D(u_texture, vec2(v_texCoord.x + 4.0 * blurSize, v_texCoord.y)) * 0.05;
    
    sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - 4.0 * blurSize)) * 0.05;
	sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - 3.0 * blurSize)) * 0.09;
	sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - 2.0 * blurSize)) * 0.12;
	sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - 1.0 * blurSize)) * 0.15;
	sum += texture2D(u_texture, vec2(v_texCoord.x                 , v_texCoord.y)) * 0.16;
	sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + 1.0 * blurSize)) * 0.15;
	sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + 2.0 * blurSize)) * 0.12;
	sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + 3.0 * blurSize)) * 0.09;
	sum += texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + 4.0 * blurSize)) * 0.05;
    
	gl_FragColor = sum/2.0;*/
    
    // Blur #2
    /*vec4 sum = vec4(0.0);
    float blurSize = 1.0/768.0;
	float i, j;
    for (i = -2.0; i <= 2.0; i++)
    {
        for (j = -2.0; j <= 2.0; j++)
        {
            sum += texture2D(u_texture, vec2(v_texCoord.x + i*blurSize, v_texCoord.y + j*blurSize));
        }
    }
	gl_FragColor = sum/25.0;*/
    
    
    
    // BLOOM
    /*vec4 sum = vec4(0);
    int j;
    int i;
    
    for ( i = -3; i < 4; i++)
    {
        for (j = -3; j < 4; j++)
        {
            sum += texture2D(u_texture, v_texCoord + vec2(j, i)*0.004) * 0.20;
        }
    }
    
    if (texture2D(u_texture, v_texCoord).r < 0.3)
    {
        gl_FragColor = sum*sum*0.012 + texture2D(u_texture, v_texCoord);
    }
    else
    {
        if (texture2D(u_texture, v_texCoord).r < 0.5)
        {
            gl_FragColor = sum*sum*0.009 + texture2D(u_texture, v_texCoord);
        }
        else
        {
            gl_FragColor = sum*sum*0.0075 + texture2D(u_texture, v_texCoord);
        }
    }*/
    
    // Bloom #2
    /*vec4 blurSample = vec4(0.0);
	vec4 tmpPix;
	vec4 offPix;
	vec2 uv = v_texCoord;
	for (float i = -4.0; i < 5.0; i++)
	{
		tmpPix = texture2D(u_texture, uv + vec2(i*0.003, 0));
		offPix = -0.3+tmpPix;
		offPix = offPix * 5.0;
		if ( (offPix.r + offPix.g + offPix.b) > 0.0 )
		{			
            blurSample = blurSample + offPix;	
		}
	}
    
	for (float i = -4.0; i < 5.0; i++)
	{
		tmpPix = texture2D(u_texture, uv + vec2(0, i*0.003));
        offPix = -0.3+tmpPix;
		offPix = offPix * 5.0;
		if ((offPix.r+offPix.g+offPix.b) > 0.0)
		{
			blurSample += offPix;
		}
        
	}
    
	blurSample = blurSample / 64.0;
	gl_FragColor = blurSample*1.2;*/
    
    
    
    // Wave
    /*vec2 resolution = vec2(1024.0, 768.0);
    vec2 cPos = -1.0 + 2.0 * v_texCoord.xy;
    float cLength = length(cPos);
    
    vec2 uv = v_texCoord.xy+(cPos/cLength)*cos(cLength*12.0-time*4.0)*0.03;
    vec3 col = texture2D(u_texture, uv).xyz;
    
    gl_FragColor = vec4(col,1.0);*/
}
