#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
varying vec4 v_fragmentColor;

void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);
    gl_FragColor = color*(v_fragmentColor + (1.0 - v_fragmentColor)*(abs(color - 0.5)*2.0));
}
