#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;

uniform sampler2D u_texture;
uniform float u_interpolation;
//uniform float u_oneMinusInterpolation;
uniform vec4 u_colorAdd;

void main()
{
    vec3 color = texture2D(u_texture, v_texCoord).xyz;
    //vec3 colorNew = color + u_colorAdd.xyz;
    //gl_FragColor.xyz = u_oneMinusInterpolation*color + u_interpolation*colorNew;
   gl_FragColor.xyz = u_colorAdd.xyz * u_interpolation + color;
}
